import dds
import ddsutil
import std_msgs/msg/Header_.std_msgs.msg.dds_
import struct

class PoseWithCovarianceStamped___TypeSupport(dds.TypeSupport):

    _typename = 'geometry_msgs::msg::dds_::PoseWithCovarianceStamped_'
    _keylist = ''
    _metadescriptor = '<MetaData version="1.0.0"><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="Point_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member></Struct><Struct name="Quaternion_"><Member name="x_"><Double/></Member><Member name="y_"><Double/></Member><Member name="z_"><Double/></Member><Member name="w_"><Double/></Member></Struct><Struct name="Pose_"><Member name="position_"><Type name="Point_"/></Member><Member name="orientation_"><Type name="Quaternion_"/></Member></Struct><Struct name="PoseWithCovariance_"><Member name="pose_"><Type name="Pose_"/></Member><Member name="covariance_"><Array size="36"><Double/></Array></Member></Struct></Module></Module></Module><Module name="builtin_interfaces"><Module name="msg"><Module name="dds_"><Struct name="Time_"><Member name="sec_"><Long/></Member><Member name="nanosec_"><ULong/></Member></Struct></Module></Module></Module><Module name="std_msgs"><Module name="msg"><Module name="dds_"><Struct name="Header_"><Member name="stamp_"><Type name="::builtin_interfaces::msg::dds_::Time_"/></Member><Member name="frame_id_"><String/></Member></Struct></Module></Module></Module><Module name="geometry_msgs"><Module name="msg"><Module name="dds_"><Struct name="PoseWithCovarianceStamped_"><Member name="header_"><Type name="::std_msgs::msg::dds_::Header_"/></Member><Member name="pose_"><Type name="PoseWithCovariance_"/></Member></Struct></Module></Module></Module></MetaData>'

    def __init__(self):
        super(PoseWithCovarianceStamped___TypeSupport, self).__init__(self._typename,
              self._keylist,
              self._metadescriptor,
              struct.calcsize(PoseWithCovarianceStamped_()._get_packing_fmt()))

    def _serialize(self, o):
        if not isinstance(o, PoseWithCovarianceStamped_):
            raise TypeError('Incorrect data type')
        result = o._serialize()
        return result

    def _deserialize(self, buf):
        result = PoseWithCovarianceStamped_()
        data = struct.unpack(result._get_packing_fmt(), buf)
        result._deserialize(list(data))
        return result

class PoseWithCovarianceStamped_(ddsutil.TopicDataClass):

    @staticmethod
    def get_type_support():
        ''' Return type support information required for dds.Topic constructor '''
        return PoseWithCovarianceStamped___TypeSupport()

    @property
    def header_(self):
        '''
        a DDS std_msgs::msg::dds_::Header_ value
        @rtype: std_msgs/msg/Header_.std_msgs.msg.dds_.Header_
        '''
        return self._header__

    _header__checker = ddsutil._class_checker(std_msgs/msg/Header_.std_msgs.msg.dds_.Header_)
    @header_.setter
    def header_(self, value):
        self._header__checker(value)
        self._header__ = value

    @property
    def pose_(self):
        '''
        a DDS geometry_msgs::msg::dds_::PoseWithCovariance_ value
        @rtype: PoseWithCovariance_
        '''
        return self._pose__

    _pose__checker = ddsutil._class_checker(PoseWithCovariance_)
    @pose_.setter
    def pose_(self, value):
        self._pose__checker(value)
        self._pose__ = value

    _member_attributes = ('header_', 'pose_')

    def __init__(self, **kwargs):
        ''' Create a PoseWithCovarianceStamped_ instance, optionally initializing fields by name '''
        # init attributes to default value
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()
        self.pose_ = PoseWithCovariance_()
        # set values for attributes passed in
        for key, value in kwargs.items():
            if key not in self._member_attributes:
                raise TypeError('Invalid argument name : %s' %(key))
            setattr(self, key, value)

    _packing_fmt = None

    @staticmethod
    def _get_packing_fmt():
        ''' Returns packing format of this class data '''
        if PoseWithCovarianceStamped_._packing_fmt is not None:
            return PoseWithCovarianceStamped_._packing_fmt
        fmt = ''
        fmt += ddsutil._align(fmt, std_msgs/msg/Header_.std_msgs.msg.dds_.Header_._get_packing_fmt())
        fmt += ddsutil._align(fmt, PoseWithCovariance_._get_packing_fmt())

        PoseWithCovarianceStamped_._packing_fmt = ddsutil._pad_fmt(fmt)
        return PoseWithCovarianceStamped_._packing_fmt

    def _serialize(self):
        ''' Serialize data for writing '''
        fmt = self._get_packing_fmt()
        args = self._get_packing_args()
        result = struct.pack(fmt, *args)
        return result

    def _deserialize(self, data):
        ''' Initialize values from data returned by struct.unpack()'''
        self.header_ = std_msgs/msg/Header_.std_msgs.msg.dds_.Header_()._deserialize(data)
        self.pose_ = PoseWithCovariance_()._deserialize(data)
        return self;

    def _get_packing_args(self):
        ''' Return an list of data suitable for struct.pack '''
        args = []
        args.extend(self.header_._get_packing_args())
        args.extend(self.pose_._get_packing_args())
        return args

